/*
*  Copyright 2019-2025 Tz
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.system.service.impl;

import me.zhengjie.modules.system.domain.BusCarousel;
import me.zhengjie.modules.system.domain.dto.BusCarouselQueryCriteria;
import me.zhengjie.modules.system.mapper.BusCarouselMapper;
import me.zhengjie.modules.system.service.BusCarouselService;
import me.zhengjie.utils.FileUtil;
import lombok.RequiredArgsConstructor;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import me.zhengjie.utils.PageUtil;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import me.zhengjie.utils.PageResult;

/**
* @description 服务实现
* @author tangz
* @date 2025-07-30
**/
@Service
@RequiredArgsConstructor
public class BusCarouselServiceImpl extends ServiceImpl<BusCarouselMapper, BusCarousel> implements BusCarouselService {

    private final BusCarouselMapper busCarouselMapper;

    @Override
    public PageResult<BusCarousel> queryAll(BusCarouselQueryCriteria criteria, Page<Object> page){
        return PageUtil.toPage(busCarouselMapper.findAll(criteria, page));
    }

    @Override
    public List<BusCarousel> queryAll(BusCarouselQueryCriteria criteria){
        return busCarouselMapper.findAll(criteria);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void create(BusCarousel resources) {
        busCarouselMapper.insert(resources);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(BusCarousel resources) {
        BusCarousel busCarousel = getById(resources.getId());
        busCarousel.copy(resources);
        busCarouselMapper.updateById(busCarousel);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteAll(List<Integer> ids) {
        busCarouselMapper.deleteBatchIds(ids);
    }

    @Override
    public void download(List<BusCarousel> all, HttpServletResponse response) throws IOException {
        List<Map<String, Object>> list = new ArrayList<>();
        for (BusCarousel busCarousel : all) {
            Map<String,Object> map = new LinkedHashMap<>();
            map.put("名称", busCarousel.getName());
            map.put("路径", busCarousel.getPath());
            map.put("排行", busCarousel.getSort());
            list.add(map);
        }
        FileUtil.downloadExcel(list, response);
    }
}